#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const effect_1 = require("effect");
const Http = __importStar(require("@effect/platform/HttpClient"));
const NodeCommandExecutor = __importStar(require("@effect/platform-node/NodeCommandExecutor"));
const NodeFileSystem = __importStar(require("@effect/platform-node/NodeFileSystem"));
const environment_1 = require("./environment");
const git_client_1 = require("./git-client");
const jira_client_1 = require("./jira-client");
const cli_1 = require("./cli");
const platform_node_1 = require("@effect/platform-node");
const commandExecutorLayer = NodeCommandExecutor.layer.pipe(effect_1.Layer.provide(NodeFileSystem.layer));
const gitClientLayer = git_client_1.GitClientLive.pipe(effect_1.Layer.provide(commandExecutorLayer));
const jiraClientLayer = jira_client_1.JiraClientLive.pipe(effect_1.Layer.provide(Http.client.layer), effect_1.Layer.provide(environment_1.EnvironmentLive));
const mainLive = effect_1.Layer.mergeAll(commandExecutorLayer, gitClientLayer, environment_1.EnvironmentLive, jiraClientLayer, platform_node_1.NodeContext.layer);
const mainEffect = (0, effect_1.pipe)(effect_1.Effect.sync(() => process.argv), effect_1.Effect.flatMap(cli_1.cliEffect), effect_1.Effect.provide(mainLive));
effect_1.Effect.runPromise(mainEffect);
